function log(msg) {
  if (window.cc && window.cc.error) {
    window.cc.error(msg)
  } else if (window.cc && window.cc.warn) {
    window.cc.warn(msg)
  } else {
    console.log(msg)
  }
}

console.log('all_in_once begin for url: ' + location.toString())

function in_frame() {
  try {
    return window.top !== window.self
  } catch (e) {
    return true
  }
}

function has_sub_frame() {
  return document.getElementsByTagName('iframe').length > 0
}

function is_cocos() {
  return !!window.cc
}

function is_egret() {
  return !!window.egret
}

function get_infos() {
  return 'is_egret: ' + is_egret() + ', is_coos: ' + is_cocos() +
      ', has_sub_frame: '
      + has_sub_frame() + ', in_frame: ' + in_frame() + ', in_game: ' +
      is_game()
}

function is_game() {
  return is_egret() || is_cocos()
}

Date._now = Date._now || Date.now
performance._now = performance._now || performance.now

Date.now = function() {
  const enable = window.__enable_speed !== false
  let speed = window.__speed || 1.0
  if (!enable) {
    speed = 1.0
  }
  if (!window.__date_now_base) {
    window.__date_now_base = performance._now()
    window.__date_now_rst = performance._now()
  }
  const rst = window.__date_now_rst + (Date._now() - window.__date_now_base) *
      speed
  window.__date_now_rst = rst
  window.__date_now_base = Date._now()
  return rst
}

performance.now = function() {
  const enable = window.__enable_speed !== false
  let speed = window.__speed || 1.0
  if (!enable) {
    speed = 1.0
  }
  if (!window.__beginPerformance_base) {
    window.__beginPerformance_base = performance._now()
    window.__beginPerformance_rst = performance._now()
  }
  const rst = window.__beginPerformance_rst +
      (performance._now() - window.__beginPerformance_base) * speed
  window.__beginPerformance_rst = rst
  window.__beginPerformance_base = performance._now()
  return rst
}

function _send_msg_to_frame(msg) {
  for (const ele of document.getElementsByTagName('iframe')) {
    console.log(
        'send msg to child frame: ' + JSON.stringify(msg) + ', frame src: ',
        ele.src)
    if (ele.contentWindow) {
      ele.contentWindow.postMessage(msg, '*')
    }
  }
}

if (window.__speed !== null && window.__speed !== undefined) {
  window.__speed = 1.0
}

window.setSpeed = function(speed) {
  console.log(
      'setSpeed called, ' + get_infos() + ', url: ' + location.toString())
  _send_msg_to_frame({
    type: 'tt_setSpeed',
    speed
  })
  if (is_game()) {
    log('in_game, so real set speed to: ' + speed + ', for url: ' +
        location.toString())
    window.__speed = speed
  } else {
    log('is not in game')
  }
}

window.setEnable = function(enable) {
  _send_msg_to_frame({
    type: 'tt_setEnable',
    enable
  })
  if (is_game()) {
    window.__enable_speed = enable
  }
}

addEventListener('message', function(param) {
  console.log('receive msg: ' + JSON.stringify(param) + ', in url: ' +
      location.toString())
  if (param.data) {
    const data = param.data
    if (data.type && data.type.startsWith('tt_')) {
      console.log('receive msg: ' + data)
      if (data.type === 'tt_setSpeed') {
        setSpeed(data.speed)
      } else if (data.type === 'tt_setEnable') {
        setEnable(data.enable)
      }
    }
  }
}, false)

console.log('all_in_once finish for url: ' + location.toString())